#include "CnuWindow.h"
#include <windows.h>
#include <tchar.h>


CnuWindow::CnuWindow()
{
}


CnuWindow::~CnuWindow()
{
}

// EBhE쐬
bool CnuWindow::RegistWindow(const TCHAR* window_class_name, const HINSTANCE hInst)
{
	_tcscpy_s(WINDOW_CLASS_NAME, window_class_name);
	m_hInstance = hInst;
	WNDCLASSEX wc;

	// EBhENX̏ݒ
	wc.cbSize = sizeof(wc);									// \̃TCY
	wc.style = CS_HREDRAW | CS_VREDRAW;						// X^C
	wc.lpfnWndProc = CnuWindow::StaticWndProc;				// EBhEvV[W
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;									// CX^Xnh
	wc.hIcon = (HICON)LoadIcon(NULL, IDI_APPLICATION);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = (HCURSOR)LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;									// j[
	wc.lpszClassName = WINDOW_CLASS_NAME;					// EBhENX

															// EBhENXo^
	if (RegisterClassEx(&wc) == 0) { return false; }

	return true;

}

bool CnuWindow::nuCreateWindow(
	LPCTSTR lpWindowName, // EBhE
	DWORD dwStyle,        // EBhEX^C
	int x,                // EBhẺ̈ʒu
	int y,                // EBhȄc̈ʒu
	int nWidth,           // EBhE̕
	int nHeight,          // EBhE̍
	HWND hWndParent,      // eEBhE܂̓I[i[EBhẼnh
	HMENU hMenu          // j[nh܂͎qEBhE ID
) {
	m_hwnd = CreateWindow(
		WINDOW_CLASS_NAME,		// EBhENX
		lpWindowName,			// ^Cgo[ɕ\镶
		dwStyle,				//  EBhE̎
		x,						// EBhE\ʒuiXWj
		y,						// EBhE\ʒuiYWj
		nWidth,					// EBhE̕
		nHeight,				// EBhE̍
		hWndParent,				// eEBhẼEBhEnh
		hMenu,					// j[nh
		m_hInstance,			// CX^Xnh
		this					// ̑̍쐬f[^
	);
	if (m_hwnd == nullptr)
		return false;

	return true;

}

LRESULT  CnuWindow::WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, msg, wp, lp);
}



LRESULT CALLBACK CnuWindow::StaticWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	CnuWindow* This = (CnuWindow*)GetWindowLongPtr(hWnd, GWLP_USERDATA);
	if (!This) {//擾łȂ(EBhE)ꍇ
		if (message == WM_CREATE) {
			This = (CnuWindow*)((LPCREATESTRUCT)lParam)->lpCreateParams;
			if (This) {
				SetWindowLongPtr(hWnd, GWLP_USERDATA, (LONG_PTR)This);
				return This->WndProc(hWnd, message, wParam, lParam);
			}
		}
	}
	else {//擾łꍇ(EBhE)
		return This->WndProc(hWnd, message, wParam, lParam);
	}
	return DefWindowProc(hWnd, message, wParam, lParam);
}

