#pragma once
#include <windows.h>

class CnuWindow
{
	TCHAR WINDOW_CLASS_NAME[1024];

	static LRESULT CALLBACK StaticWndProc(
		HWND hWnd, 
		UINT msg, 
		WPARAM wp, 
		LPARAM lp);

private:
	HWND m_hwnd;
	HINSTANCE m_hInstance;
public:
	CnuWindow();
	virtual ~CnuWindow();

	//! @brief EBhE`po֐
	bool RegistWindow(
		const TCHAR* window_class_name, 
		const HINSTANCE hInst
	);

	//! @brief EBhEvV[W
	virtual LRESULT WndProc(
		HWND hWnd, 
		UINT msg, 
		WPARAM wp, 
		LPARAM lp
	);

	HWND GetHWnd()const { return m_hwnd; }
	HINSTANCE GetHInstance()const { return m_hInstance; }

	//! @brief EBhE쐬po֐
	bool nuCreateWindow(
		LPCTSTR lpWindowName,	// EBhE
		DWORD dwStyle,			// EBhEX^C
		int x,					// EBhẺ̈ʒu
		int y,					// EBhȄc̈ʒu
		int nWidth,				// EBhE̕
		int nHeight,			// EBhE̍
		HWND hWndParent,		// eEBhE܂̓I[i[EBhẼnh
		HMENU hMenu				// j[nh܂͎qEBhE ID
	);

};

